# Celifinder

**Celifinder** es una aplicación para encontrar y localizar restaurantes celíacos, que añade otras funcionalidades como información sobre su oferta apta de platos o tapas sin gluten, cerveza sin gluten, etc.


## Demo

En el fichero zip comprimido se incluye un video demostración de la funcionalidad de la aplicación sobre un dispositivo iOS (iPhone 6s)

## Instalación del Backend

En este zip encontrará 3 ficheros de instalación:

* backup_celifinder.sql  
Se trata del fichero backup de la base de datos en formato .sql

* back-project.zip  
Fichero comprimido con el proyecto de Spring Boot, que actuará como backend conectándose a la bbdd y dando respuesta a las peticiones front-end

* expo-pack.zip  
Fichero comprimido con el proyecto de React-Native desarrollado mediante Expo, que nos permitirá ejecutar el proyecto en los simuladores tanto de iOS como de Android **mediante Expo** 

* native-pack.zip  
Fichero comprimido con el proyecto de React-Native desarrollado que nos permitirá generar los proyectos nativos de la app, con Android Studio y XCode, respectivamente

### Base de datos

En primer lugar es necesario obtener la base de datos a través del fichero backup_celifinder.sql. La versión de MySql que se ha utilizado es 8.0.12

Una vez la base de datos está instalada, se podrá comprobar que dentro de ella hay 3 tablas:

* restaurante
* usuario
* comentario

### Backend

Al descomprimir el fichero se obtendrá un directorio con los ficheros necesarios para formar un proyecto de Spring Boot. 

Es necesario tener STS (Sprint Tool Suite) instalada. La versión utilizada en este proyecto fue 3.9.6.RELEASE

Desde STS se importa el proyecto desde el directorio al que se haya descargado. 

Una vez podamos ver el proyecto importado en el Package Explorer, se selecciona sobre la carpeta raíz con el botón derecho y se selecciona: Run as > Maven install.

Si han cambiado la contraseña o el nombre de usuario de la base de datos, habrá que cambiarlo en el fichero

	src/main/resources/application.properties

Posteriormente en el BootDashboard se selecciona el nombre del proyecto y se arranca mediante el botón 'Run or restart process'

## Instalación del Frontend

Para la instalación de la parte Frontend hay dos proyectos a partir de los cuales se puede arrancar la app.

Por un lado el proyecto contenido en expo-pack.zip que nos permite ver la app mediante Expo, evitando tener que generar los proyectos nativos de Android Studio y XCode.

Por otro lado el proyecto contenido en native-pack.zip está preparado y configurado para generar loas proyectos nativos de XCode y de Android Studio respectivamente.

Ambos comparten el mismo código fuente (contenido en /src y otros ficheros .js) pero la configuración de cada proyecto es diferente dependiendo de la finalidad de los mismos.

### Arranque de la app con Expo

Al descomprimir el fichero expo-pack.zip, obtenemos un directorio.

Para arrancar el proyecto front necesitamos las siguientes librerías

*	Node (v10.1.0)
*  Yarn (v1.7.0)
*  NPM (v5.6)

Mediante consola accedemos a este directorio e instalamos las dependencias mediante:

	yarn
	
o, como alternativa:
	
	npm install

Es necesario comprobar en qué dirección IP y en qué puerto está arrancado el proyecto de Back. En el fichero /src/redux/apis/utils.api.js hay una variable string llamada basePath. En caso de ser una IP diferente deberá modificarse su valor con la iP y el puerto donde está expuesto el proyecto de backend.

Una vez se han instalado las dependencias correctamente se arranca el proyecto con el siguiente comando:

	yarn start

Aparecerá lo siguiente en consola. 

![Front console] (./img/front.png)

Si se tiene simulador de iOS o de Android (generados por XCode o Android Studio respectivamente) se podrá arrancar la aplicación pulsando sobre las letras 'i' (para iOS) y 'a' (para Android). 


También se podrá escanear el código QR con un dispositivo móvil de tal forma que se abrirá la aplicación mediante la aplicación Expo. 

La aplicación de Expo se puede descargar gratuitamente en:

*	[iOS](https://itunes.apple.com/us/app/expo-client/id982107779?mt=8)
*	[Android](https://play.google.com/store/apps/details?id=host.exp.exponent&hl=es) 

### Arranque de la app con los proyectos nativos

Al descomprimir el fichero native-pack.zip, obtenemos un directorio.

Para arrancarlo necesitamos las siguientes librerías (al igual que en el proyecto de arranque con Expo):

*	Node (v10.1.0)
*  Yarn (v1.7.0)
*  NPM (v5.6)

Mediante consola accedemos a este directorio e instalamos las dependencias mediante:

	yarn
	
o, como alternativa:
	
	npm install

Los proyectos, tanto de XCOde como de Android Studio, están generados, en el .zip, pero para que la app nativa funcione correctamente, antes hay que modificar la dirección IP donde está arrancado el servidor. Para ello, en el fichero /src/redux/apis/utils.api.js hay una variable string llamada basePath. En caso de ser una IP diferente deberá modificarse su valor con la iP y el puerto donde está expuesto el proyecto de backend.

Una vez se han instalado las dependencias correctamente se vuelven a generar los proyectos de XCode y de Android Studio.

Para generar el proyecto de XCode se ejecuta el siguiente comando

	react-native run-ios
	
En el directiorio /ios estará el proyecto de Xcode, donde se podrá ejecutar la app de forma nativa.

Para generar la app nativa de Android Studio se ejecuta el siguiente comando, teniendo un simulador de Android arrancado:

	react-native run-android
	
Una vez se haya terminado de generar la app nativa, ésta se habrá instalado de forma nativa en el simulador de Android.

En el directiorio /android estará el proyecto de Android Studio.

## Contenido de este fichero comprimido

En el fichero zip comprimido se incluye el siguiente contenido:

Ficheros con la implementación del proyecto:

* backup_celifinder.sql  
* back-project.zip  
* expo-pack.zip  
* native-pack.zip  

Fichero Readme:

*	directorio img
*  readme.md (este fichero)
*  readme.pdf (en formate PDF por si no se pudiera visualizar correctamente en .md)

Otros:

* demo.mp4: Video demostración de la	funcionalidad de la aplicación
* PEC3_LendoiroValleBlanca.pdf: Memoria actualizada (a falta de las conclusiones y de las lineas futuras de trabajo de la aplicación)  